LintCode 123 · Word Search (DFS字符处理经典题!)

123 · Word Search

Algorithms

Medium

Description

Given a 2D board and a string word, find if the string word exists in the grid.

The string word can be constructed from letters of sequentially adjacent cell, where "adjacent" cells are those horizontally or vertically neighboring.

The same letter cell may not be used more than once.

The dimension of the letter matrix does not exceed 100, and the length of the string does not exceed 100.

Example

Example 1:

Input:

board = "ABCE","SFCS","ADEE"

word = "ABCCED"

Output:

true

Explanation:

A B C E S F C S A D E E

(0,0)->(0,1)->(0,2)->(1,2)->(2,2)->(2,1)

Example 1:

Input:

board = "z"

word = "z"

Output:

true

Explanation:

z

(0,0)

解法1:DFS+hashset。

很多小地方需要注意,特别是visited\[\]\[\]数组什么时候clear掉。

cpp 复制代码
class Solution {
public:
    /**
     * @param board: A list of lists of character
     * @param word: A string
     * @return: A boolean
     */
    bool exist(vector<vector<char>> &board, string &word) {
        int m = board.size();
        if (m == 0) return word.empty();
        int n = board[0].size();
        string sol = "";
        for (int i = 0; i < word.size(); i++) {
            string tmpStr = word.substr(0, i + 1);
            s.insert(tmpStr);
        }
        vector<vector<bool>> visited;
        for (int i = 0; i < m; i++) {
            for (int j = 0; j < n; j++) {
                sol.clear(); //这里每次都要clear!不然后面的操作就append到s上面!
                visited.resize(m, vector<bool>(n, false));
                sol += board[i][j];
                if (check(board, word, sol, visited, i, j)) return true;
            }
        }
        return false;
    }
private:
    int dx[4] = {0, 0, 1, -1};
    int dy[4] = {1, -1, 0, 0};
    set<string> s;
    bool check(vector<vector<char>> &board, string &word, string sol, vector<vector<bool>> &visited, int x, int y) {
        if (s.find(sol) == s.end()) return false;
        if (sol == word) {
            return true;
        }
        if (sol.size() >= word.size()) return false;
        visited[x][y] = true;
        for (int i = 0; i < 4; i++) {
            int newX = x + dx[i];
            int newY = y + dy[i];
            if (newX >= 0 && newX < board.size() && newY >= 0 && newY < board[0].size() && !visited[newX][newY]) {
                sol += board[newX][newY];
                if (check(board, word, sol, visited, newX, newY)) return true;
                else sol.pop_back();  //这一行重要!因为sol还要被for循环的其它i用到!
            }
        }
        visited[x][y] = false; //这一行重要,只有当dfs能够一直往下进行,visited[][]才不用动,否则如果dfs中途退出,visited[][]要clear。不然就跟后面操作冲突!
        return false; //这里别忘了,不然默认可能会返回true!!!
    }
};

二刷:不需要set。每次比较当前位置的字符就可以了。

cpp 复制代码
class Solution {
public:
    /**
     * @param board: A list of lists of character
     * @param word: A string
     * @return: A boolean
     */
    bool exist(vector<vector<char>> &board, string &word) {
        int m = board.size();
        if (m == 0) return word.empty();
        int n = board[0].size();
        string sol = "";
        vector<vector<bool>> visited;
        for (int i = 0; i < m; i++) {
            for (int j = 0; j < n; j++) {
                sol.clear();
                visited.resize(m, vector<bool>(n, false));
                sol += board[i][j];
                if (check(board, word, sol, 0, visited, i, j)) return true;
            }
        }
        return false;
    }
private:
    int dx[4] = {0, 0, 1, -1};
    int dy[4] = {1, -1, 0, 0};
    bool check(vector<vector<char>> &board, string &word, string sol, int pos, vector<vector<bool>> &visited, int x, int y) {
        if (sol[pos] != word[pos]) return false;
        if (sol == word) {
            return true;
        }
        //if (sol.size() >= word.size()) return false; //这一行不需要!如果不匹配早就返回了,匹配上面也会返回true。
        visited[x][y] = true;
        for (int i = 0; i < 4; i++) {
            int newX = x + dx[i];
            int newY = y + dy[i];
            if (newX >= 0 && newX < board.size() && newY >= 0 && newY < board[0].size() && !visited[newX][newY]) {
                sol += board[newX][newY];
                if (check(board, word, sol, pos + 1, visited, newX, newY)) return true;
                else sol.pop_back();  //这一行重要!因为sol还要被for循环的其它i用到!
            }
        }
        visited[x][y] = false; //这一行重要,只有当dfs能够一直往下进行,visited[][]才不用动,否则如果dfs中途退出,visited[][]要clear。不然就跟后面操作冲突!
        return false;
    }
};

三刷: DFS+Trie

TBD

四刷:BFS

TBD

相关推荐
信息安全失业大专人员8 小时前
每日了解一个智能体-WorkBuddy
开发语言·ai·c#·智能体
呆呆敲代码的小Y8 小时前
【实战精选面试题】C# 面试题详细解答,按难易程度排序
android·java·游戏·c#·游戏开发·unity面试题·c#面试题
淡海水9 小时前
09-01-内存-Unity资源生命周期全景
unity·c#·游戏引擎·.netcore·gc
椒颜皮皮虾྅12 小时前
让 C# 读懂整张图:DeploySharp 驱动 PaddleOCR v4/v5/v6,打通 OCR 全流程
开发语言·人工智能·深度学习·学习·c#·ocr·cuda
昂好的day13 小时前
C# 同步异步与多线程:Thread / Task / 线程池一次讲透(上篇)
开发语言·windows·c#
CQU_JIAKE13 小时前
10.31[A]
算法·深度优先
吃一碗粉只付一碗钱21 小时前
12-给SPA友好的401和403响应
c#·状态模式
caimouse1 天前
MonoDevelop 编译用户应用程序时调用的是哪个编译器
c#
will_net1 天前
apollo 站点部署&C#接入
开发语言·c#·apollo
海绵宝宝转agent1 天前
LeetCodehot100题解
java·笔记·学习·算法·leetcode·深度优先